controlChange = { }

local defsize = 100

local cc = { }

local function new( x, y, text, section, bind )
	local key = controls[ section ][ bind ]
	if x == "center" then x = display.width / 2 - 50 end
	table.insert( cc, { x = x, y = y, w = 200, h = 200, section = section, bind = bind, key = key, text = text, selected = false } )
end

function controlChange.update( dt )
	local mx, my = love.mouse.getPosition( )
	for k, v in pairs( cc ) do
		if mx >= v.x and mx <= v.x + 100 and my >= v.y and my <= v.y + 100 then
			v.selected = true
		else
			v.selected = false
		end
	end
end

function controlChange.draw( )
	for k, v in ipairs( cc ) do
		if v.selected then
			love.graphics.setColour( 130, 80, 156 )
		else
			love.graphics.setColour( 0, 0, 0 )
		end
		local tempKey = v.key
		if tempKey == " " then tempKey = "space" end
		love.graphics.rectangle( "fill", v.x + camera.x, v.y + camera.y, v.w / 2, v.h / 2 )
		love.graphics.setFont( fonts.body )
		love.graphics.setColour( 255, 255, 255 )
		love.graphics.printf( tempKey, v.x + camera.x, v.y + camera.y + 40, v.w / 2, "center" )
		love.graphics.setColour( 25, 25, 25 )
		love.graphics.printf( v.text, v.x + camera.x, v.y + 110 + camera.y, v.w / 2, "center" )
	end
end

function controlChange.setKey( key )
	for k, v in pairs( cc ) do
		if v.selected then
			v.key = key
		end
	end
end

function loadControlChanges( )
	new( 100, 150, "Move Left", "move", "left" )
	new( 250, 150, "Move Right", "move", "right" )
	new( 400, 150, "Jump", "move", "jump" )
	print( table.serialize( cc, true, true ) )
end	

function controlChange.updateKeyBinds( )
	for k, v in pairs( cc ) do
		controls[ v.section ][ v.bind ] = v.key
	end
end

function controlChange.reset( )
	for k, v in pairs( cc ) do
		local key = controls[ v.section ][ v.bind ]
		v.key = key
	end
end