game = { }
game.worldTick = 0
game.worldTickRate = 1/60

function game.draw()
     if gamestate == "Main Menu" or gamestate == "ChooseWorldType" or gamestate == "Help" or gamestate == "Escape" or gamestate == "Options" then
          love.graphics.setBackgroundColor(255,255,255,255)
     elseif gamestate == "Editor" or gamestate == "Game" then
          love.graphics.setBackgroundColour( unpack( worldType.sky ) )
          love.graphics.draw( texture.hills, 200, camera.y )
     else
          love.graphics.setBackgroundColor(0,0,0,255)
     end
     if gamestate == "Editor" then
          editor.draw()
     end
     if gamestate == "Options" then
          love.graphics.setColor(0,0,0,255)
          love.graphics.setFont(fonts.title)
          text.centerPrint("OPTIONS")
          love.graphics.setFont(fonts.body)
     end
     if gamestate == "Main Menu" or gamestate == "Choose Game Type" or gamestate == "Escape" then
          local r,g,b,a = love.graphics.getColor()
          love.graphics.setColor(0,0,0,255)
          love.graphics.setFont(fonts.title)
          text.centerPrint("MINIDIGGER",200)
          love.graphics.setFont(fonts.body)
          text.centerPrint("a game by eric bernard",350)
          text.rightPrint( version, display.height - 25, 10 )
          love.graphics.setColor(r,g,b,a)
     end
     if gamestate == "SaveWorldName" or gamestate == "LoadWorldName" then
          text.centerPrint("World Name: "..textinput,display.height/2)
     end
     if gamestate == "Game" then
          map.draw()
     end
     if gamestate == "ChooseWorldType" then
          love.graphics.setColor(0,0,0,255)
          love.graphics.setFont( fonts.minititle )
          text.centerPrint("Choose a world type",25)
     end
     if gamestate == "Controls" then
         love.graphics.setBackgroundColour( 255, 255, 255 )
         love.graphics.setFont( fonts.minititle )
         text.centerPrint("Change Controls",25) 
         love.graphics.setFont( fonts.body )
         text.centerPrint( "Hover over a block and press desired key to bind", 115 )
     end
     if gamestate == "Dead" then
          love.graphics.setBackgroundColour( 158, 104, 107 )
          love.graphics.setColour( 255, 255, 255 )
          love.graphics.setFont( fonts.title )
          text.centerPrint( "You died!", 200 )
     end
end

function game.update(dt)
     --[=[if gamestate == "Editor" then
          editor.update(dt)
     end
     if gamestate == "Game" then
          map.update(dt)
     end--]=]

     game.worldTick = game.worldTick + dt
     while game.worldTick > game.worldTickRate do
          game.doPhysicsUpdate( game.worldTickRate )
          game.worldTick = game.worldTick - game.worldTickRate
     end
end

function game.doPhysicsUpdate( time )
     if gamestate == "Editor" then
          editor.update( time )
          player.update( time )
     end
end