map = {tiles={}}
col = {} --COLLIDER TABLE

function map.load(name)
	love.filesystem.setIdentity(defaultDir.."/maps")
	chunkMap = love.filesystem.load(name)
	love.filesystem.setIdentity(defaultDir)
	map.tiles = chunkMap()

	World = love.physics.newWorld(0,100)
	for k,v in ipairs(map.tiles) do
		if v.id ~= 0 then
			col[k] = {}
			col[k].frame = {}
			local ptype = nil
			if v.id == "7" then --ADD BLOCKS THAT SHOULD REACT TO GRAVITY / PHYSICS
				ptype = "dynamic"
			else
				ptype = "static"
			end
			col[k].frame.body = love.physics.newBody(World,v.x,v.y,ptype)
			col[k].frame.body:setLinearDamping(0)
			col[k].frame.body:setFixedRotation(true)
			col[k].frame.body:setAngle(0)
			col[k].frame.shape = love.physics.newRectangleShape(50,50)
			col[k].frame.fixture = love.physics.newFixture(col[k].frame.body,col[k].frame.shape,1)
			col[k].x = nil
			col[k].y = nil
		end
	end
end

function map.update(dt)
	World:update(dt)
	for k,v in ipairs(col) do
		v.x = v.body:getX()
		v.y = v.body:getY()
	end
end

function map.draw()
	for k,t in ipairs(map.tiles) do
		if t.id ~= nil then
			love.graphics.draw(texture[t.id],col[k].x,col[k].y)
		end
	end
end

function map.unload()
	World:destroy()
end