player = { }

local animationTimer = 0
local animationThreshold = 0.2 --seconds between frames

function player.load( )

	player.w = 32
	player.h = 40

	player.speed = 1
	player.gravity = worldType.gravity * 0.05
	player.friction = 0.5
	player.jump = -1 

	player.jumpCount = 0

	player.x = ( editor.worldSize * editor.tdefsize ) / 2
	player.y = 1000
	player.yvel = 0
	player.xvel = 0

	player.jump = -2

	player.direction = "left"

	player.inventory = { }

	player.doTick = true

	player.animation = { up = { }, down = { }, left = { }, right = { } }
	local dir = "images/character/"
	for k, v in pairs( love.filesystem.getDirectoryItems( dir ) ) do
		for i, j in pairs( love.filesystem.getDirectoryItems( dir..v.."/" ) ) do
			player.animation[ v ][ i ] = love.graphics.newImage( dir..v.."/"..j )
			print( "loaded image file " .. dir .. v .. j )
		end
	end

	player.activeskin = 1
	player.isJumping = false
	player.isFalling = false
	player.canJump = true

	player.mass = 50

	camera.y = player.y
	camera.x = player.x - ( display.width / 2 )

end

local function animate( dt )

	if player.isJumping and player.doTick then
		player.activeskin = 1
	else
		animationTimer = animationTimer + dt
		if animationTimer >= animationThreshold then
			animationTimer = 0
			local c = player.activeskin + 1
			if #player.animation[ player.direction ] < c then
				player.activeskin = 1
			else
				player.activeskin = player.activeskin + 1
			end
		end
	end

end

function player.filter( item, other )
	--ADD OTHER CODE BUT FOR NOW...
	return "slide"
end

local function moveCamera( dt )
	local absolutex = player.x - camera.x
	local absolutewidth = display.width - camera.x

	local absolutey = player.y - camera.y
	local absoluteheight = display.height - camera.y

	local xCameraLimit = 150
	local yCameraLimit = 250

	if absolutex > display.width - xCameraLimit --[=[and love.keyboard.isDown( controls.move.right )]=] then
		camera.x = player.x - display.width + xCameraLimit
	elseif absolutex < xCameraLimit --[=[and love.keyboard.isDown( controls.move.left )]=] then
		camera.x = player.x - xCameraLimit
	end
	if absolutey > display.height - yCameraLimit then
		camera.y = player.y - display.height + yCameraLimit
	elseif absolutey < yCameraLimit then
		camera.y = player.y - yCameraLimit
	end
end

function player.update( dt )
	moveCamera( dt )
	
	if player.doTick then
		local ddx = 0
		local speed = player.speed

		if player.yvel > 0.2 then
			player.isFalling = true
		else
			player.isFalling = false
		end

		if love.keyboard.isDown( controls.move.left, controls.move.right ) and not player.isJumping and not player.isFalling then
			animate( dt )
			--player.friction = -0.5
		else
			player.activeskin = 1
			ddx = -( ( player.xvel ) * player.friction * dt )
		end

		--print( player.friction )

		if player.yvel > 0.5 then 
			player.isFalling = true
		else
			player.isFalling = false
		end

		if player.jumpCount == 2 then
			player.canJump = false
		end

		if love.keyboard.isDown( controls.move.jump ) and not player.isJumping and player.canJump then
			player.yvel = player.jump
			player.jumpCount = player.jumpCount + 1
			
			player.isJumping = true
			player.canJump = false
		end

		if love.keyboard.isDown( controls.move.left ) then
			--player.xvel = player.xvel - player.speed
			--if math.abs( player.xvel ) > player.speed * 10 then player.xvel = player.speed end
			ddx = -( player.speed * dt )
			player.direction = "left"
		elseif love.keyboard.isDown( controls.move.right ) then
			--player.xvel = player.xvel + player.speed
			--if player.xvel > player.speed * 10 then player.xvel = player.speed end
			ddx = player.speed * dt
			player.direction = "right"
		end

		if love.keyboard.isDown( controls.move.sprint ) then
			player.speed = 2.5
		else
			player.speed = 1
		end

		player.xvel = player.xvel + ddx

		player.xvel = clamp( player.xvel, -0.4, 0.4 )

		--print( player.xvel )

		player.yvel = player.yvel + player.gravity

		local cols
		player.x, player.y, cols, cols_len = world:move( player, player.x + player.xvel, player.y + player.yvel, player.filter )
		if #cols > 0 then
			player.isJumping = false
			--player.canJump = true
			player.jumpCount = 0
			--print( cols[ 1 ].normal.x )
			if cols[ 1 ].normal.x == 0 then
				player.yvel = 0
			elseif cols[ 1 ].normal.x == -1 or cols[ 1 ].normal.x == 1 then
				player.xvel = 0
			elseif cols[ 1 ].normal.y == -1 then
				player.friction = 0.1
			end
		else
			player.friction = 2
		end
		if player.y > 4000 then
			player.kill( )
		end
	end
end

function player.draw( )
	love.graphics.draw( player.animation[ player.direction ][ player.activeskin ], player.x - 17, player.y - 25 )
	--love.graphics.rectangle( "fill", player.x, player.y, player.w, player.h )
end

function player.generateCollider( )
	world:add( player, player.x, player.y, player.w, player.h )
	player.doTick = true
end

function player.kill( )
	player.doTick = false
	world:remove( player )
	gamestate = "Dead"
end