setup = {}

function setup.images( )
	texture = {}

	local imagesToLoad = love.filesystem.getDirectoryItems("images/tiles")
	for i=1,#imagesToLoad do
		if imagesToLoad[i] ~= "Thumbs.db" then
			local imageName = string.sub(imagesToLoad[i],1,-5)
			texture[imageName] = love.graphics.newImage("images/tiles/"..imagesToLoad[i])
			print("Loaded "..imageName.." successfully")
		end
	end
	texture.hills = love.graphics.newImage( "images/background/main.png" )
end

function setup.sounds( )
	music = love.audio.newSource("sounds/music/main.mp3")
	love.audio.setVolume(1)
end

function setup.fonts( )
	fonts = {}
	fonts.button = love.graphics.newFont( "fonts/dimitri.TTF", 40 )
	fonts.body = love.graphics.newFont( "fonts/pixeab.TTF", 17 )
	fonts.title = love.graphics.newFont( "fonts/blank.otf", 150 )
	fonts.minititle = love.graphics.newFont( "fonts/blank.otf", 75 )
	fonts.button2 = love.graphics.newFont( "fonts/pixeab.TTF", 40 )
	fonts.tiny = love.graphics.newFont( "fonts/blank.otf", 25 )
end

function setup.display( )
	display = {}
	display.width = love.window.getWidth( )
	display.height = love.window.getHeight( )
end

function setup.controls( )
	controls = { }

	--

	controls.move = { jump = " ", left = "a", right = "d", sprint = "lshift", }
end

function setup.load( )
	setup.images( )
	setup.sounds( )
	setup.fonts( )
	setup.display( )

	setup.controls( )

	defaultDir = "MiniDigger"

end